/*== Includes ========================================================*/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <string.h>
#include <bios.h>
#include <malloc.h>

/*== Makros ==========================================================*/
                                                                        
#ifndef MK_FP                    /* wurde MK_FP noch nicht definiert? */
#define MK_FP(seg, ofs) ((void far *) ((unsigned long) (seg)<<16|(ofs)))
#endif

/*== Funktion Prototypes =============================================*/
short CheckInst();


/*== Konstanten und Makros ===========================================*/
#define I2F_FKT_0  0xAA		 /* Code fr INT 2F, Funktion 0       */

unsigned char i2f_fktcode;	 /* Codenummer fr Multiplexer	      */



/**********************************************************************/
/* CheckInst:  stellt fest, ob das Programm bereits installiert ist   */
/* Aufruf :    short CheckInst();				      */
/* Return-Wert : !=0, wenn das Programm bereits installiert war,      */
/*		 sonst 0					      */
/**********************************************************************/
short CheckInst()
{
  unsigned isinst=0;
  unsigned tmp;
  union _REGS regs;
  struct _SREGS sregs;
  int i;

  i2f_fktcode=0xC0;

  for(i=0x40; i!=0; i--)
    {
      regs.h.ah = i2f_fktcode;		 /* Funktionsnummer Multiplexer	   */
      regs.h.al = 0;			 /* Unterfunktion 0		   */
      _int86x(0x2f,&regs,&regs,&sregs);  /* Multiplexer aufrufen	   */

      if(regs.h.al == 0xff)		 /* wenn Code 0xff besetzt	   */
	{
	  regs.h.ah = i2f_fktcode;	    /* Funktionsnummer Multiplexer */
	  regs.h.al = I2F_FKT_0;	    /* Unterfunktion 0		   */
	  tmp = regs.x.ax;		    /* Registerinhalt merken	   */
	  _int86x(0x2f,&regs,&regs,&sregs); /* Multiplexer aufrufen	   */

		   /* high und low Byte tauschen */
	  tmp = ((tmp>>8)&0x00ff) | ((tmp<<8)&0xff00);

		   /* wenn high und low Byte getauscht sind */
		   /* ist bereits eine Kopie des TSR aktiv  */
	  if(regs.x.ax == tmp)
	    {		   /* TSR bereits installiert */
		isinst = regs.x.bx;
	    }
	  else
	    {		   /* TSR noch nicht installiert */
		isinst = 0;
	    }
	}
      if(isinst) break;
      i2f_fktcode++;
    }
  return(isinst);  /* und zurck */
}
